# Mxpf halp to hit some non spoofed email that domain doesnt have SPF or DKIM
# It compare the B mask of sender ip with B mask of all mx records of domain

package Mail::SpamAssassin::Plugin::mxpf;
1;

use strict;
use Socket;
use Net::DNS;
use Mail::SpamAssassin;
use Mail::SpamAssassin::Plugin;
use Mail::SpamAssassin::Message::Metadata::Received qw(parse_received_line);
our @ISA = qw(Mail::SpamAssassin::Plugin);


sub new {
 my ($class, $mailsa) = @_;
 $class = ref($class) || $class;
 my $self = $class->SUPER::new( $mailsa );
 bless ($self, $class);
 $self->register_eval_rule ( 'check_pf' );
 return $self;
}

sub check_pf {
 my ($self, $msg) = @_;
 my $msgr = $msg->get_message();
 # Get untrusted relay ip
 my @untrusted = @{$msgr->{metadata}->{relays_untrusted}};
 my $relay = shift(@untrusted);
 my $msgip = $relay->{ip};
 # Go on only if msgip have a value
 if (defined($msgip)) {
  #dbg# Mail::SpamAssassin::Plugin::dbg( "mxpf: Message Ip : " . $msgip );
  # Class B of msgip to compare
  #This is for use comparing C class# my ($msgipclass) = $msgip =~ /^(\d+\.\d+\.\d+)/;
  my ($msgipclass) = $msgip =~ /^(\d+\.\d+)/;
  #dbg# Mail::SpamAssassin::Plugin::dbg( "mxpf: Message Ip Class : " . $msgipclass );
  # Get from address and split into user and domain 
  my $msgfrom = $msg->get( 'From:addr' );
  # Go on only if msgfrom contains at least a @ and a .
  if (index ($msgfrom, "@" ) != -1 && index ($msgfrom, "." ) != -1) {
   #dbg# Mail::SpamAssassin::Plugin::dbg( "mxpf: Message From : " . $msgfrom );
   my ($msguser, $msgdomain) = $msgfrom =~ /(.*)@(.*)/;
   #dbg# Mail::SpamAssassin::Plugin::dbg( "mxpf: User : " . $msguser );
   #dbg# Mail::SpamAssassin::Plugin::dbg( "mxpf: Domain : " . $msgdomain );
   # Search MX record for from domain
   my $amx="";
   my $aip="";
   my $mxname="";
   my $mxip="";
   my $resmx = Net::DNS::Resolver->new;
   my $resip = Net::DNS::Resolver->new;
   # Dns Timeouts
   $resmx->udp_timeout(3);
   $resmx->tcp_timeout(3);
   $resip->udp_timeout(3);
   $resip->tcp_timeout(3);
   # Scan mx records
   my @mx = mx($resmx, $msgdomain);
   if (@mx) {
    foreach $amx (@mx) {
     $mxname=$amx->exchange;
     #dbg# Mail::SpamAssassin::Plugin::dbg("mxpf: Mx : " . $mxname);
     # Resolve ip of mx
     my $ip = $resip->search($mxname);
     if ($ip) {
      foreach $aip ($ip->answer) {
       $mxip=$aip->address;
       #dbg# Mail::SpamAssassin::Plugin::dbg("mxpf: Mx Ip: " . $mxip);
       #This is for use comparing C class# my ($mxipclass) = $mxip =~ /^(\d+\.\d+\.\d+)/;
       my ($mxipclass) = $mxip =~ /^(\d+\.\d+)/;
       #dbg# Mail::SpamAssassin::Plugin::dbg("mxpf: Mx Ip Class: " . $mxipclass);
       # Comparing mxipc with msgipc
       if ($mxipclass eq $msgipclass) {
        # Return 1 and close if match
        #dbg# Mail::SpamAssassin::Plugin::dbg( "mxpf:  END WITH MATCH" );
        return 1;
       }
      }
     }
    }
   }
  }
 }
 #dbg# Mail::SpamAssassin::Plugin::dbg( "mxpf:  END WITHOUT MATCH" );

return 0;
}

